



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Laravel如何优雅的使用Swoole</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Laravel如何优雅的使用Swoole</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-24 10:43:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>背景</h2>
<p>正在做一个智能家居的项目（钱低的吓死人怎么办），接收下位机（就是控制智能家居硬件模块的HUB）协议解析，Web端维护硬件状态，利用APP交互。由于下位机数据是发送到服务器的XXX端口，所以必须对XXX端口进行监听。其实和聊天室的概念差不多，研究了一下workerman、swoole和其他几个开源的项目，决定采用swoole。</p>
<p>关于php解析下位机的16进制协议，其实相当之扯蛋，要是你最好还是用.NET或者JAVA吧。很久没碰MVC了，光是为解析协议写webservice觉得钱又太TM低了，哈哈哈，所以直接上PHP吧。网上搜搜还没见几个php这样搞的项目，我还没做完，做完了来谈谈，关键函数主要是bin2hex/pack/unpack。这一篇主要聊聊Laravel如何优雅的使用Swoole，其实只需简单3步就可以完成。</p>
<h2>什么是Swoole</h2>
<p>直接套用<a href="http://www.swoole.com/" rel="external nofollow noreferrer">Swoole官网</a>的介绍：PHP的异步、并行、高性能网络通信引擎，使用纯C语言编写，提供了PHP语言的异步多线程服务器，异步TCP/UDP网络客户端，异步MySQL，异步Redis，数据库连接池，AsyncTask，消息队列，毫秒定时器，异步文件读写，异步DNS查询。 Swoole内置了Http/WebSocket服务器端/客户端、Http2.0服务器端。</p>
<p>Swoole官网的文档不够丰富啊，这比较头疼，但大部分的问题都解释了。如果你对Swoole很感兴趣，那么看看这个<a href="https://github.com/LinkedDestiny/swoole-doc" rel="external nofollow noreferrer">Swoole入门教程</a>。Swoole提供了多线程、长连接等很多牛逼的功能，把php上升到了一个新的台阶，具体的你可以看看入门教程，本文只限于讨论Laravel和Swoole的结合。</p>
<p>Swoole为了提供服务，必须以CLI模式运行，什么是CLI模式呢？如果你Swoole业务代码是写在一个叫server.php的文件中，那么在命令行下输入<strong>php server.php</strong>开启。这是比较头疼的事情，因为Laravel框架可不是这样的运转的，那如何能与Laravel结合呢？没错，自定义一条Artisan Command，就这么简单。</p>
<h2>STEP 1-自定义Command</h2>
<p>关于自定义Artisan Commnad，你需要了解的技术点都在<a href="http://www.golaravel.com/laravel/docs/4.2/commands/" rel="external nofollow noreferrer">这里</a>,我自定义了一个叫做SwooleCommand的命令，直接贴关键代码：</p>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/252329/201606/252329-20160608123903855-331848480.png" /></p>
<div>fire是入口</div>
</div>
<p>在命令行（CLI）下执行<strong>php artisan swoole start</strong>即可开启Swoole服务。分析一下代码，你可以看到命令参数包括启动、重启、关闭，我图省事只实现了启动部分，如果需要关闭，在linux中利用kill命令关闭进程，步骤挺简单的:</p>
<pre class="prettyprint linenums"><code>1.执行 ps -aux|grep artisan命令，获取pid（有多个进程，杀第一个即可）<br />
2.执行 kill pid命令，pid是第一步你获取的</code></pre>
<p>关于Swoole的配置不是本文讨论的范围，请移步<a href="http://wiki.swoole.com/wiki/page/p-server.html" rel="external nofollow noreferrer">官网</a>，这里把Swoole服务用$serv变量进行了保存，是为了后面Laravel发送命令交互。你可以看到，Swoole的事件响应代码是这样的：</p>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/252329/201606/252329-20160608123909058-1440433814.png" /></p>
<div>用Handler处理事件响应</div>
</div>
<p>如果说fire打开了Swoole的大门，那么这里的handler就是Swoole与Laravel的传送带，利用自己写的handler,就可以把各种业务逻辑写进Laravel框架中，然后就可以使用Laravel提供的各种高效方便的功能了。&ldquo;handler&rdquo;是一种命名习惯，你也可以叫做"callback"、"manager"、"listener"，这看你的命名习惯了。我没有采用new的方式而是用Laravel的IoC注入<strong>App::make</strong>，主要是图省事(因为handler的构造器用到了我自定义的数据处理类,往下看)。</p>
<h2>STEP 2-自定义handler</h2>
<p>因为是自定义的类，请遵循命名空间，并在composer.json中声明，完了执行<strong>composer dump-autoload</strong>命令更新一遍。比如我创建了一个文件夹<strong>app\handlers</strong>存放handler，那么在composer.json中看起来是这样的:</p>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/252329/201606/252329-20160608123913480-1109173831.png" /></p>
<div>autoload不能少</div>
</div>
<p>那么handler里面具体干些啥，就由你来决定了。反正和写controller差不多，各种Laravel框架的功能你都能随便用，贴上我的：</p>
<div><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/252329/201606/252329-20160608123918902-448327656.png" /></div>
<p>上一节我提到我用IoC是因为构造器里面用到了自己的数据处理类，我把增删改查和其他数据处理的业务放到Repository中了，没其他原因，只是这样代码看起来清爽一点。如此，利用Swoole接收数据的流程就算搞定了，那么要想利用Swoole向客户端发送数据该怎么做呢？咳咳，这个稍微麻烦点，需要曲线方法实现，继续看下一节。</p>
<h2>STEP 3-发送数据</h2>
<p>有两种方法，但都离不开一个缓存kv结构(Laravel自带的Cache功能就够了)，保存客户端的地址数据，要不你怎么知道发到哪里去。我用的是第一种，图省事，发送数据和Swoole就无关了，如果你需要长连接websocket，这种不适用，老老实实用第二种吧。如果你有更好的办法，请一定要告诉我！</p>
<h4>第一种:fsockopen</h4>
<p>挺简单的，和swoole就没关系了，利用Swoole的<strong><a href="http://wiki.swoole.com/wiki/page/p-connection_info.html" rel="external nofollow noreferrer">connection_info</a></strong>函数获取客户端的IP地址和端口，然后用fsockopen直接发送数据。</p>
<h4>第二种:内部端口监听</h4>
<p>Swoole支持<a href="http://wiki.swoole.com/wiki/page/525.html" rel="external nofollow noreferrer">监听多个端口</a>,实现的思想就是利用fsockopen把数据利用内部监听的端口发送过去，然后就可以调用$serv发送消息了。这么做的好处就是不需要知道客户端的实际IP地址和端口，在Cache保存客户端的$fd标识，直接就发数据。采用这个思路，请记得iptables把端口打开。我自己并没有采用，因为不是长连接我觉得太麻烦。</p>
<h2>总结</h2>
<p>Swoole非常棒，其实都没怎么用上（项目钱给够再说吧）。你还可以参考<a href="http://wiki.swoole.com/wiki/page/326.html" rel="external nofollow noreferrer">官网的配置</a>，将Swoole作为nginx承载代理，据说性能提升很大。qq群533838427</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e1xkk9.html">Masonry介绍与使用实践：快速上手Autolayout</a>
		</li>
						<li><a href="https://www.batexi.com/a/3904rkm8.html">SQL数据库</a>
		</li>
						<li><a href="https://www.batexi.com/a/3906mnn9.html">&lbrack;团队项目&rsqb;SCRUM项目4&period;0</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn2o30q.html">APP完整的启动流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2xmv8.html">Python学习教程&lpar;learning Python&rpar;--2&period;3&period;3 Python函数型参详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0l1ggq.html">ASP&period;NET MVC&plus;Bootstrap个人博客之praise&period;js点赞特效插件&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjgr4z9.html">delphi 修改Hint的字体和颜色</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjzvgl8.html">运行循环 - RunLoop</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzg11e8.html">deeplearning&period;ai 神经网络和深度学习 week1 深度学习概论 听课笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv25kzy9.html">python 学习笔记 4 ----&amp;gt&semi; dive into python 3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlle600q.html">浅谈利用同步机制解决Java中的线程安全问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o112meq.html">激活IDEA方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdlmdd9.html">Marriage Match IV HDU - 3416（最短路 &plus; 最大流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvdz7j8.html">华为Python 算法面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllv3n6q.html">kubernetes1&period;4新特性（一）：支持sysctl命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjld2q.html">django模型中的关系对应</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5vdy7q.html">虚拟机ubuntu新增挂载点进行磁盘扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv31ll8.html">twisted的tcp&period;py分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p3krr8.html">SQL server数据库压缩空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjxzor8.html">24点扑克牌游戏&mdash;&mdash;（含java源码）（GUI实现）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/3901jwn8.html">初次体验VS2015正式版，安装详细过程。</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pvxz49.html">Java api 入门教程 之 JAVA的包装类</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2622v9.html">my&lowbar;strcmp&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kd20j9.html">php cli方式下获取服务器ip</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mxkp29.html">PlaceHolder的两种实现方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26gww9.html">2-Fedora 17系统安装准备</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv733oq.html">&lbrack;书目20160526&rsqb;Brain Rules 让大脑自由：释放天赋的12条定律</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o221l9.html">ASP&period;NET执行模型之IIS服务器处理流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxl4z8.html">Gvr SDK for Unity 分析&lpar;一&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyon228.html">excel技巧</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
